node {
    stage('Checkout') {
        checkout scm

        def packageJSON = readJSON file: 'package.json'
        def packageJSONVersion = packageJSON.version
        echo "VERSION:${packageJSONVersion} GIT_BRANCH:${env.BRANCH_NAME}"
    }


    stage('Install') {
        withEnv(["PATH+jdk=${tool 'node'}/bin"]) {
            sh "npm install"
        }
    }
    
    stage('Build') {
        withEnv(["PATH+jdk=${tool 'node'}/bin"]) {
            sh "npm run build-ci"
            archiveArtifacts artifacts: 'dist/*'
        }
    }
    
    stage('Unit-Tests'){
        withEnv(["PATH+jdk=${tool 'node'}/bin"]) {
            if(env.WITH_COVERAGE) {
                sh "npm run test-ci"
                archiveArtifacts artifacts: 'coverage/**/*'
            }else {
                sh "npm run test-ci-without-coverage"
            }
        }
    }
    
    stage('SonarQube') {
        withEnv(["PATH+jdk=${tool 'node'}/bin"]) {
            sh "/Users/chloenoger/.sonar/sonar-scanner-4.2.0.1873-macosx/bin/sonar-scanner -Dsonar.organization=chloe-nger -Dsonar.projectKey=chloe.nger_examen15052020 -Dsonar.sources=. -Dsonar.host.url=https://sonarcloud.io -Dsonar.login=${SONAR_LOGIN}"
        }
        
    }
}